<template>
  <div class="main tabs_main" style="height:89%">
    <div class="main_header">
      <div class="header_item">
        <span class="header_label">项目名称：</span>
        <el-select v-model="search.proId" placeholder="请选择项目名称" clearable  @change="getNumberList">
            <el-option
                v-for="item in optionsProjects"
                :key="item.proId"
                :label="item.proName"
                :value="item.proId">
            </el-option>
        </el-select>
      </div>
      <div class="header_item">
        <span class="header_label">模具编号：</span>
        <el-select v-model="search.mouldNum" placeholder="请选择模具编号" clearable filterable>
            <el-option
                v-for="(item,index) in optionsMoulds"
                :key="index"
                :label="item.mouldNum"
                :value="item.mouldNum">
            </el-option>
        </el-select>
      </div>
      <div class="header_item">
        <span class="header_label">模具型号：</span>
        <el-select v-model="search.mouldCode" placeholder="请选择模具型号" clearable>
            <el-option
                v-for="(item,index) in optionsCodes"
                :key="index"
                :label="item.mouldCode"
                :value="item.mouldCode">
            </el-option>
        </el-select>
      </div>
      <div class="header_item">
        <el-button icon="el-icon-search" v-if="showButton('search')" @click="searchButtonInfo(true)">查询</el-button>
        <el-button class="search_btn" icon="el-icon-plus" v-if="showButton('insert')" @click="insertProp">新增</el-button>
      </div>
    </div>
    <div class="main_content">
      <el-table
        v-loading="loading"
        :data="dataList"
        height="100%">
        <el-table-column align="center" label="序号" width="60">
          <template #default="scope">
            <span>{{(pageNum - 1) * pageSize + scope.$index + 1}}</span>
          </template>
        </el-table-column>
        <el-table-column prop="proName" label="项目名称" align="center" ></el-table-column>
        <el-table-column prop="mouldNum" label="模具编号" align="center" ></el-table-column>
        <el-table-column prop="mouldCode" label="模具型号" align="center" ></el-table-column>
        <el-table-column prop="blockNum" label="块号" align="center" show-overflow-tooltip></el-table-column>
        <el-table-column prop="size" label="尺寸" align="center" show-overflow-tooltip></el-table-column>
        <el-table-column prop="turn" label="转向" align="center"></el-table-column>
        <el-table-column prop="groutingHole" label="注浆孔" align="center"></el-table-column>
        <el-table-column prop="content" label="检测内容" show-overflow-tooltip align="center"></el-table-column>
        <el-table-column prop="checkDate" label="检查表日期" align="center"></el-table-column>
        <el-table-column prop="checkUnit" label="检测单位" align="center"></el-table-column>
        <el-table-column label="操作" align="center" width="150">
          <template #default="{ row }">
            <el-button class="table_btn" size="mini" v-if="showButton('update')" @click="updateProp(row)">修改</el-button>
            <el-button class="delete_btn" size="mini"  v-if="showButton('delete')" @click="deleteInfo(row)">删除</el-button>
          </template>
        </el-table-column>
      </el-table>
    </div>
    <div class="main_footer">
      <el-pagination
        background
        @current-change="changePageNum"
        @size-change="changePageSize"
        :current-page="pageNum"
        :page-sizes="[10, 20, 50, 100]"
        :page-size="pageSize"
        layout="total, sizes, prev, pager, next, jumper"
        :total="total">
      </el-pagination>
    </div>
    <el-dialog
      class="prop_dialog"
      :title="asyncTitle === true ? '新增' :'修改'"
      :close-on-click-modal="false"
      :visible.sync="asyncVisible"
      width="45%">
      <el-form ref="ruleForm" :model="ruleForm" :rules="rules" label-width="auto" class="rule_form">
        <el-form-item label="项目名称" prop="proId">
          <el-select v-model="ruleForm.proId" placeholder="请选择项目名称"  @change="getNumberList">
                <el-option
                    v-for="item in optionsProjects"
                    :key="item.proId"
                    :label="item.proName"
                    :value="item.proId">
                </el-option>
            </el-select>
        </el-form-item>
        <el-form-item label="模具编号" prop="mouldNum">
          <el-select v-model="ruleForm.mouldNum" placeholder="请选择模具编号" clearable @change="getSizeLists(1)">
                <el-option
                    v-for="(item,index) in optionsMoulds"
                    :key="index"
                    :label="item.mouldNum"
                    :value="item.mouldNum">
                </el-option>
            </el-select>
        </el-form-item>
        <el-form-item label="模具型号" prop="mouldCode">
          <el-select v-model="ruleForm.mouldCode" placeholder="请选择模具型号" clearable @change="getSizeLists(2)">
                <el-option
                    v-for="(item,index) in optionsCodes"
                    :key="index"
                    :label="item.mouldCode"
                    :value="item.mouldCode">
                </el-option>
            </el-select>
        </el-form-item>
        <el-form-item label="块号" prop="blockNum">
          <el-input v-model="ruleForm.blockNum" :size="size" clearable placeholder="请输入块号" :disabled="true"></el-input>
        </el-form-item>
        <el-form-item label="尺寸：" prop="size">
          <el-input v-model="ruleForm.size" :size="size" clearable placeholder="请输入尺寸" :disabled="true"></el-input>
        </el-form-item>
        <el-form-item label="转向：" prop="turn">
          <el-input v-model="ruleForm.turn" :size="size" clearable placeholder="请输入转向" :disabled="true"></el-input>
        </el-form-item>
        <el-form-item label="注浆孔：" prop="groutingHole">
          <el-input v-model="ruleForm.groutingHole" :size="size" clearable placeholder="请输入注浆孔" :disabled="true"></el-input>
        </el-form-item>
        <el-form-item label="检测内容：" prop="content">
          <el-input v-model="ruleForm.content" :size="size" type="textarea" :rows="3" clearable placeholder="请输入检测内容"></el-input>
        </el-form-item>
        <el-form-item label="上传检查表：" prop="files">
          <upload-file :file-list.sync="ruleForm.files">
                <template #info>
                    <span>点击上传文件，支持xls、xlsx、ppt、doc、docx、pdf格式</span>
                </template>
          </upload-file>
        </el-form-item>
        <el-form-item label="检查表日期：" prop="checkDate">
            <el-date-picker
                v-model="ruleForm.checkDate"
                type="date"
                value-format="yyyy-MM-dd HH:mm:ss"
                placeholder="请选择日期">
            </el-date-picker>
        </el-form-item>
        <el-form-item label="检测单位：" prop="checkUnit">
          <el-input v-model="ruleForm.checkUnit" :size="size" clearable placeholder="请输入检测单位"></el-input>
        </el-form-item>
      </el-form>
      <div slot="footer">
        <el-button  @click="asyncVisible = false">取 消</el-button>
        <el-button class="submit_btn" @click="asyncTitle ? submitInsert() : submitUpdate()">提 交</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { buttonPinia } from '../../../pinia/index';
import UploadFile from '../../../components/uploadFile';
import { throttle, changeSize } from '../../../plugins/public'; // 导入节流、动态切换组件尺寸方法
  export default {
    components:{
       UploadFile
    },
    data() {
      return {
        size: changeSize(), // 组件尺寸
        pageNum: 1,
        pageSize: 10,
        search:{},//查询条件
        total: 0,
        loading: false,
        dataList: [], //模具尺寸检查信息列表
        asyncTitle: true, // 对话框title 新增：true  修改：false
        asyncVisible: false, // 添加 修改对话框
        ruleForm: {
            files:[]
        }, // 按钮表单
        rules: {
        files: [{
            required: true,
            message: '请选择上传文件',
            trigger: ['blur','change']
          }],
          proId: [{
            required: true,
            message: '请选择项目名称',
            trigger: 'change'
          }],
          mouldNum: [{
            required: true,
            message: '请选择模具编号',
            trigger: ['blur','change']
          }],
          mouldCode: [{
            required: true,
            message: '请选择模具型号',
            trigger: ['change','blur']
          }],
          checkDate: [{
            required: true,
            message: '请选择检查表日期',
            trigger: 'change'
          }],
          content: [{
            required: true,
            message: '请输入检测内容',
            trigger: 'blur'
          }],
          checkUnit: [{
            required: true,
            message: '请输入检测单位',
            trigger: 'blur'
          }],
        },
        optionsMoulds:[],//模具编号
        optionsCodes:[],//模具型号
        optionsProjects:[],//所有项目
      }
    },
    watch: {
      asyncVisible(bol) {
        if(!bol) {
          this.ruleForm = {};
          this.$refs.ruleForm.resetFields();
        }else{
            this.$set(this.ruleForm,'files',[])
        }
      }
    },
    mounted() {
      const that = this;
      // 根据窗口大小动态修改组件尺寸
      window.onresize = () => {
        that.size = changeSize();
      }
    },
    methods: {
    //获得所有项目
    getAllPersons(){
        let params = {
            pageNum: 1,
            pageSize: 100000000
        }
        this.$api.Engineer.searchProjects(params).then(res=>{
            if(res.statusMsg === 'ok'){
                this.optionsProjects = res.data.list
            }else{
                this.$message.warning(res.statusMsg)
            }
        })
    },
    //根据项目获取编号,型号
    getNumberList(val){
        if(this.asyncVisible===false&&this.search.proId ===''){
            this.$set(this.search,'mouldNum','')
            this.$set(this.search,'mouldCode','')
        }
        if(this.asyncTitle){
            this.$set(this.ruleForm,'mouldNum','')
            this.$set(this.ruleForm,'mouldCode','')
            this.$set(this.ruleForm,'blockNum','')
            this.$set(this.ruleForm,'size','')
            this.$set(this.ruleForm,'turn','')
            this.$set(this.ruleForm,'groutingHole','')
        }
        this.$api.Quality.getMouldNumberLists({proId:val}).then(res=>{
            if(res.statusMsg === 'ok'){
                this.optionsMoulds = res.data
            }else{
                this.$message.warning(res.statusMsg)
            }
        })
        this.$api.Quality.getMuuldCodeLists({proId:val}).then(res=>{
            if(res.statusMsg === 'ok'){
                this.optionsCodes = res.data
            }else{
                this.$message.warning(res.statusMsg)
            }
        })
    },
    //获取尺寸等信息
    getSizeLists(val){
        let params
        if(this.asyncTitle){
            params={
                proId:this.ruleForm.proId,
                mouldNum:this.ruleForm.mouldNum,
                mouldCode:this.ruleForm.mouldCode
            }
        }else{
            params={
                proId:this.ruleForm.proId,
                mouldNum:this.ruleForm.mouldNum,
                mouldCode:this.ruleForm.mouldCode
            }
        }
        if(val===1){
            this.$set(this.ruleForm,'mouldCode','')
            let obj = {proId:this.ruleForm.proId,mouldNum:this.ruleForm.mouldNum}
            this.$api.Quality.getMuuldCodeLists(obj).then(res=>{
                if(res.statusMsg === 'ok'){
                    this.optionsCodes = res.data
                }else{
                    this.$message.warning(res.statusMsg)
                }
            })
        }else{
            this.$api.Quality.getProjectThroughSizes(params).then(res=>{
                if(res.statusMsg === 'ok'){
                    this.$set(this.ruleForm,'blockNum',res.data.mouldTypeName)
                    this.$set(this.ruleForm,'size',res.data.mouldSizeName)
                    this.$set(this.ruleForm,'turn',res.data.mouldTurnName)
                    this.$set(this.ruleForm,'groutingHole',res.data.groutingHolesName)
                }else{
                    this.$message.warning(res.statusMsg)
                }
            })
        }
    },
      // 查询按钮列表信息
      searchButtonInfo(bol) {
        if(bol) {
          this.pageNum = 1;
        }
        let params = Object.assign({},this.search,{
          pageNum: this.pageNum,
          pageSize: this.pageSize
        })
        this.loading = true;
        this.$api.Quality.searchQulityLists(params).then((res) => {
          if(res.statusMsg === 'ok') {
            this.total = res.data.total;
            this.dataList = res.data.list;
          }else{
            this.$message.warning(res.statusMsg)
          }
          this.loading = false;
        })
      },
      // 新增按钮信息
      insertProp() {
        this.asyncTitle = true;
        this.asyncVisible = true;
      },
      // 修改按钮信息
      updateProp(row) {
        this.asyncTitle = false;
        this.asyncVisible = true;
        this.getNumberList(row.proId)
        this.$api.Quality.detailsQulityInfo({id: row.id}).then(res=>{
            if(res.statusMsg === 'ok'){
                this.ruleForm = res.data
                this.$set(this.ruleForm, 'files', res.data.moldQualityFileEntities.map((item, index) => {
                    const type = item.fileName.split('.');
                    return {
                        id: index + 1,
                        type: type[type.length - 1],
                        name: item.fileName,
                        url: item.fileUrl
                    }
                }))
                res.data.tbigPaths.filter(iten=>iten.fileType ===1).map(item=>{
                    this.imageList.push({
                        id: this.imageList.length + 1,
                        url:`https://szpipe.thhy-tj.com/${item.filePath}`,
                        name:item.filePathName,
                        nameImg:item.filePathName
                    })
                })
            }else{
                this.$message.warning(res.statusMsg)
            }
        })
      },
      // 删除按钮信息
      deleteInfo(row) {
        this.$confirm("该操作将删除该信息，是否继续删除?", "提示", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
       })
       .then(() => {
         this.$api.Quality.deleteQulityInfo({id: row.id})
        .then(res => {
          if(res.statusMsg === 'ok') {
            this.searchButtonInfo(true);
            this.$message.success("删除成功！");
          } else {
            this.$message.warning(res.statusMsg);
          }
        })
       })
       .catch(() => {
         this.$message.warning("您已取消");
       })
      },
      // 提交添加按钮信息
      submitInsert: throttle(function() {
        this.$refs.ruleForm.validate((valid) => {
          if(valid) {
            const params = Object.assign({}, this.ruleForm);
            params.moldQualityFileEntities = params.files&&params.files.map(item => {
               return {
                    fileName:item.name,
                    fileUrl:item.url
               }
            });
            delete params.files
            this.$api.Quality.addQulityInfo(params).then((res) => {
              if(res.statusMsg === 'ok') {
                this.asyncVisible = false;
                this.searchButtonInfo(true);
                this.$message.success('添加成功！');
              } else {
                this.$message.warning(res.statusMsg);
              }
            })
          }
        })
      }, 3000),
      // 提交修改按钮信息
      submitUpdate: throttle(function() {
        this.$refs.ruleForm.validate((valid) => {
          if(valid) {
            const params = Object.assign({}, this.ruleForm);
            params.moldQualityFileEntities = params.files&&params.files.map(item => {
               return {
                    fileName:item.name,
                    fileUrl:item.url
               }
            });
            delete params.files
            this.$api.Quality.updateQulityInfo(params).then((res) => {
              if(res.statusMsg === 'ok') {
                this.asyncVisible = false;
                this.searchButtonInfo(true);
                this.$message.success('修改成功！');
              } else {
                this.$message.warning(res.statusMsg);
              }
            })
          }
        })
      }, 3000),
      // 判断按钮权限信息
      showButton(str) {
        const pinia = buttonPinia();
        return pinia.$state.buttonInfo.includes(str);
      },      
      // 切换页数
      changePageNum(page) {
        this.pageNum = page;
        this.searchButtonInfo();
      },
      // 切换每页条数
      changePageSize(size) {
        this.pageSize = size;
        this.searchButtonInfo();
      }
    }
  }
</script>

<style lang="sass" scoped>
@import '../../../style/layout-main.scss';
</style>